// $Id: media_library.js,v 1.1.2.5 2010/05/28 16:41:18 franz Exp $

(function ($) {

  Drupal.media_library = Drupal.media_library || {};

  Drupal.media_library.BrowseClick = function(context) {
    $(this).find('input').attr('checked', 'checked');
    $(this).parents('form').submit();
  };

  // Our Ctools command for inserting the tag inside the textarea
  Drupal.CTools.AJAX.commands.ml_insert = function(data) {
    textarea = $(data.selector).get(0);
    
    if (window.document.selection) {
    	// IE
      textarea.focus();
      cursor = window.document.selection.createRange();
      cursor.text = data.data;
    }
    else if (textarea.selectionStart || textarea.selectionStart == "0") {
    	// Gecko-based engines: Mozilla, Camino, Firefox, Netscape
      var startPos  = textarea.selectionStart;
      var endPos    = textarea.selectionEnd;
      var body      = textarea.value;
      textarea.value = body.substring(0, startPos) + data.data + body.substring(endPos, body.length);
    }
    else {
    	// Worst case scenario: browsers that don't know about cursor position:
    	// Safari, OmniWeb, Konqueror
      textarea.value += data.data;
    }
    Drupal.attachBehaviors($(data.selector));
  };

  Drupal.theme.prototype.media_library_preview = function(data, inner) {
    var content = data.preview;
    content += '<div style="display:none" class="ml-tag">' + data.tag + '</div>';
    if (inner == 0) 
      content = '<div name="mceItemMediaLibrary" class="mceItemMediaLibrary">' + content + '</div>';
    return content;
  }
  
  Drupal.CTools.AJAX.commands.ml_insert_tiny = function(data) {
    content = Drupal.theme('media_library_preview', data.data, 0);
    tinyMCE.editors[data.data.id].execCommand('mceInsertContent', false, content);
  };

  Drupal.CTools.AJAX.commands.ml_update_tiny = function(data) {
    content = Drupal.theme('media_library_preview', data.data, 0);
    tinyMCE.editors[data.data.id].execCommand('mceReplaceContent', false, content);
  };

  // Process textareas to add the link.
  Drupal.behaviors.media_library = function(context) {
    $('textarea.media-library:not(.media-library-processed)', context).each(function() {
      // Drupal's teaser behavior is destructive and needs to be run first.
      if ($(this).is('textarea.teaser:not(.teaser-processed)')) {
        Drupal.behaviors.teaser(context);  
      }
      $(this).addClass('media-library-processed').parent().append(Drupal.theme('media_library_link', this));
      // We need this because our link has to be processed by CToolsModal
      Drupal.behaviors.CToolsModal(context);
    });
    $('.ctools-use-modal-processed a:not(.ctools-use-modal, .ctools-use-modal-processed)', context).each(function() {
      $(this).addClass('ctools-use-modal');
      Drupal.behaviors.CToolsModal(context);
    });
    $('#media-library-browse-form div:not(.media-library-browse-processed)', context).each(function() {
      $(this).addClass('media-library-browse-processed');
      $(this).click(Drupal.media_library.BrowseClick);
    });
  }
  
  Drupal.theme.prototype.media_library_link = function(el) {
    var html = '<div class="media-library-link-wrapper">'; 
    var link = Drupal.t('Add Media');
    html += '<a href="'+ Drupal.settings.basePath +
      'index.php?q=media-library/main&textarea='+ el.id +
      '" class="media-library-link ctools-use-modal" id="media-library-link-'+ el.id +
      '" title="'+ Drupal.t('Click here to add media content') + '">' +
      link +'</a>';
    html += '</div>';
    return html;
  }
  
})(jQuery);
